// Need these defined in order to get the timer functions we need.
#define NTDDI_VERSION NTDDI_WINXPSP2
#define _WIN32_WINNT 0x0501

#include "Samurize.h"
#include <windows.h>
#include "ftd2xx.h"

//===========================================================================
//
// Library Prototypes
//
//===========================================================================
SAMURIZE_PLUGIN_CHAR openConnection( int deviceId, FT_HANDLE* usbDevice );
SAMURIZE_PLUGIN_CHAR readFromTBan( FT_HANDLE usbDevice, char* data );

//===========================================================================
//
// Samurize Prototypes
//
//===========================================================================

BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call,
                       LPVOID lpReserved );
SAMURIZE_PLUGIN_CHAR init();
SAMURIZE_PLUGIN_INT  dlltype();
SAMURIZE_PLUGIN_CHAR getinfo( int infoNum );
SAMURIZE_PLUGIN_INT  dllstartup( HWND hwnd, int dlltype );
SAMURIZE_PLUGIN_INT  dllshutdown( int id );
SAMURIZE_PLUGIN_INT  pastemeter( int thesource, int thedest );
SAMURIZE_PLUGIN_CHAR getparam( char* func );
SAMURIZE_PLUGIN_INT configure();
SAMURIZE_PLUGIN_INT source_configure( int id, char* func );
SAMURIZE_PLUGIN_CHAR GetDigitalTemp( int id, char* digitalSensorIndex );
SAMURIZE_PLUGIN_CHAR GetAnalogTemp( int id, char* analogSensorIndex );
SAMURIZE_PLUGIN_CHAR GetFanRPM( int id, char* fanIndex );
SAMURIZE_PLUGIN_CHAR GetFanPercentage( int id, char* fanIndex );
SAMURIZE_PLUGIN_CHAR GetFanMaxRPM( int id, char* fanIndex );
SAMURIZE_PLUGIN_CHAR GetValue( int id, char* parameterIndex );


//===========================================================================
//
// Linker options.  Used by MSVC++ to remap the library symbols to the
// names that Samurize requires.
//
//===========================================================================

#pragma comment(linker, "/EXPORT:init=_init@0") 
#pragma comment(linker, "/EXPORT:dlltype=_dlltype@0") 
#pragma comment(linker, "/EXPORT:getinfo=_getinfo@4") 
#pragma comment(linker, "/EXPORT:dllstartup=_dllstartup@8") 
#pragma comment(linker, "/EXPORT:dllshutdown=_dllshutdown@4") 
#pragma comment(linker, "/EXPORT:pastemeter=_pastemeter@8") 
#pragma comment(linker, "/EXPORT:getparam=_getparam@4") 
#pragma comment(linker, "/EXPORT:configure=_configure@0") 
#pragma comment(linker, "/EXPORT:source_configure=_source_configure@8") 
#pragma comment(linker, "/EXPORT:GetDigitalTemp=_GetDigitalTemp@8") 
#pragma comment(linker, "/EXPORT:GetAnalogTemp=_GetAnalogTemp@8") 
#pragma comment(linker, "/EXPORT:GetFanRPM=_GetFanRPM@8") 
#pragma comment(linker, "/EXPORT:GetFanPercentage=_GetFanPercentage@8") 
#pragma comment(linker, "/EXPORT:GetFanMaxRPM=_GetFanMaxRPM@8") 
#pragma comment(linker, "/EXPORT:GetValue=_GetValue@8") 
#pragma comment(linker, "/EXPORT:openConnection=_openConnection@8") 
#pragma comment(linker, "/EXPORT:readFromTBan=_readFromTBan@8") 
